unit UnitThermometer03Temperature;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,printers, Grids, Spin, Thermometer{..\Thermometer.dcu};

type
  TFormThermometer03Temperature = class(TForm)
    PrintDialog1: TPrintDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    Label00: TLabel;
    LabelGappiNamae: TLabel;
    Label001: TLabel;
    LabelAnswer1: TLabel;
    LabelProjectName: TLabel;
    LabelHyoudai1: TLabel;
    Thermometer1: TThermometer;
    Thermometer2: TThermometer;
    LabelAnswer2: TLabel;
    Thermometer3: TThermometer;
    LabelAnswer3: TLabel;
    Thermometer4: TThermometer;
    LabelAnswer4: TLabel;
    Thermometer5: TThermometer;
    LabelAnswer5: TLabel;
    Thermometer6: TThermometer;
    LabelAnswer6: TLabel;
    PanelButtons: TPanel;
    ButtonNew: TButton;
    ButtonStart: TButton;
    ButtonPrinterSetup: TButton;
    ButtonPrintOut: TButton;
    GroupBoxStart: TGroupBox;
    ButtonRadioGroupStartClose: TButton;
    StringGrid1: TStringGrid;
    RadioGroupUnit: TRadioGroup;
    GroupBoxThermometer: TGroupBox;
    GroupBoxScale: TGroupBox;
    RadioGroupBoardCharacter: TRadioGroup;
    RadioGroupLine: TRadioGroup;
    GroupBoxMeterRange: TGroupBox;
    LabelMeterMax: TLabel;
    LabelMeterMin: TLabel;
    SpinEditMeterMax: TSpinEdit;
    SpinEditMeterMin: TSpinEdit;
    RadioGroupBackGroundColor: TRadioGroup;
    RadioGroupBarColor: TRadioGroup;
    GroupBoxRandom: TGroupBox;
    GroupBoxThermoRange: TGroupBox;
    LabelThermoMax: TLabel;
    LabelThermoMIn: TLabel;
    SpinEditThermoMax: TSpinEdit;
    SpinEditThermoMin: TSpinEdit;
    RadioGroupRandom: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
    procedure ButtonPrintOutClick(Sender: TObject);
    procedure RadioGroupRandomClick(Sender: TObject);
    procedure ButtonPrinterSetupClick(Sender: TObject);
    procedure ButtonRadioGroupStartCloseClick(Sender: TObject);
    procedure Renew(Sender: TObject);
    procedure LabelHyoudaiRenew(Sender: TObject);
    procedure ButtonStartClick(Sender: TObject);
    procedure RadioGroupBoardCharacterClick(Sender: TObject);
    procedure RadioGroupLineClick(Sender: TObject);
    procedure RadioGroupUnitClick(Sender: TObject);
    procedure RadioGroupBarColorClick(Sender: TObject);
    procedure SpinEditThermoMinChange(Sender: TObject);
    procedure SpinEditThermoMaxChange(Sender: TObject);
    procedure SpinEditMeterMaxChange(Sender: TObject);
    procedure SpinEditMeterMinChange(Sender: TObject);
    procedure RadioGroupBackGroundColorClick(Sender: TObject);
  private
    { Private 錾 }
    procedure RansuuHassei;
  public
    { Public 錾 }
  end;

var
  FormThermometer03Temperature: TFormThermometer03Temperature;

var hours,minutes:integer;
    PenWidthBorderLine: integer;
    PenWidthScaleNoon: integer;
    PenWidthScale1Minutes: integer;
    PenWidthScale5Minutes: integer;
    PenWidthLongHand: integer;
    PenWidthShortHand: integer;
var px10,py10,px20,py20,px30,py30,px40,py40,px50,py50:integer;
var px11,py11,px21,py21,px31,py31,px41,py41,px51,py51:integer;

implementation

{$R *.DFM}

var division: integer;
var sRadioGroupBoardCharacter,
    sRadioGroupLine,
    sSpinEditMeterMax,
    sSpinEditMeterMin,
    sSpinEditThermoMax,
    sSpinEditThermoMin,
    sRadioGroupRandom,
    sThermometerBarColor,
    sThermometerTypeUnitKind: string;

procedure TFormThermometer03Temperature.RansuuHassei;
var i: integer;
begin
  randomize;
  for i:=1 to 6 do
  begin
    case RadioGroupRandom.ItemIndex of
      0: StringGrid1.Cells[i,1]:= inttostr(SpinEditThermoMin.value+ random(SpinEditThermoMax.Value-SpinEditThermoMin.value+1) div 10*10);
      1: StringGrid1.Cells[i,1]:= inttostr(SpinEditThermoMin.value+ random(SpinEditThermoMax.Value-SpinEditThermoMin.value+1) div 5*5);
      2: StringGrid1.Cells[i,1]:= inttostr(SpinEditThermoMin.value+ random(SpinEditThermoMax.Value-SpinEditThermoMin.value+1));
      else StringGrid1.Cells[i,2]:= inttostr(0);
    end;
  end;
  Thermometer1.value:=strtoint(StringGrid1.Cells[1,1]);
  Thermometer2.value:=strtoint(StringGrid1.Cells[2,1]);
  Thermometer3.value:=strtoint(StringGrid1.Cells[3,1]);
  Thermometer4.value:=strtoint(StringGrid1.Cells[4,1]);
  Thermometer5.value:=strtoint(StringGrid1.Cells[5,1]);
  Thermometer6.value:=strtoint(StringGrid1.Cells[6,1]);
end;

procedure TFormThermometer03Temperature.FormCreate(Sender: TObject);
var c: integer;
begin
  LabelProjectName.caption:='Thermometert03Temperature';
  
  sRadioGroupBoardCharacter:='';
  sRadioGroupLine:='';
  sSpinEditMeterMax:='';
  sSpinEditMeterMin:='';
  sSpinEditThermoMax:='';
  sSpinEditThermoMin:='';
  sRadioGroupRandom:='';
  sThermometerBarColor:='';
  sThermometerTypeUnitKind:='';

  Color:= clWhite;

  BorderStyle:= bsSizeable;
  PrintScale:= poPrintToFit;
  Scaled:= True;

  PenWidthBorderLine:=1;
  PenWidthScaleNoon:=5;
  PenWidthScale1Minutes:=1;
  PenWidthScale5Minutes:=2;
  PenWidthLongHand:=6;
  PenWidthShortHand:=10;

  RadioGroupBoardCharacter.ItemIndex:=0;
  RadioGroupLine.ItemIndex:=0;
  RadioGroupUnit.itemIndex:=0;
  RadioGroupRandom.itemIndex:=1;
  RadioGroupBarColor.ItemIndex:=0;
  RadioGroupBackGroundColor.ItemIndex:=0;
  SpinEditMeterMax.Value:=50;
  SpinEditThermoMax.Value:=50;

  ButtonStart.Hide;
  Stringgrid1.Hide;
  Stringgrid1.EditorMode:= true;
  StringGrid1.ColWidths[0]:= 36;
  for c:=1 to 6 do stringgrid1.Cells[c,0]:=inttostr(c);
  for c:=1 to 6 do stringgrid1.Cells[c,1]:='0';
  Stringgrid1.Cells[0, 0]:='';
  StringGrid1.Cells[0, 1]:='x';

  renew(sender);
end;

procedure TFormThermometer03Temperature.FormDblClick(Sender: TObject);
begin
  FormCreate(Sender);
end;

procedure TFormThermometer03Temperature.ButtonPrinterSetupClick(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TFormThermometer03Temperature.ButtonPrintOutClick(Sender: TObject);
begin
  GroupBoxStart.Hide;
  PanelButtons.Hide;

  printer.Orientation:= poLandscape;//v^ZbgAbv_CAOʂAڂɉuɐݒ
  Printer.Title:=self.Text;
  Self.Print;

  PanelButtons.show;
  GroupBoxStart.Show;

  renew(sender);
end;

procedure TFormThermometer03Temperature.RadioGroupRandomClick(Sender: TObject);
var sDivision: string;
begin
  case RadioGroupRandom.itemindex of
    0: begin
         division:= 10;
         sdivision:=':10x, ';
       end;
    1: begin
         division:= 5;
         sdivision:=':5x, ';
       end;
    2: begin
         division:= 1;
         sdivision:=':1x, ';
       end;
  end;
  SpinEditThermoMin.Increment:=division;
  SpinEditThermoMax.Increment:=division;
  if SpinEditThermoMin.Value> division then SpinEditThermoMin.Value:= 0;
  SpinEditThermoMin.Value:= trunc(SpinEditThermoMin.Value / division) * division;
  SpinEditThermoMax.Value:= trunc(SpinEditThermoMax.Value / division) * division;
  sRadioGroupRandom:=''+sDivision;
  LabelHyoudaiRenew(sender);
end;

procedure TFormThermometer03Temperature.ButtonRadioGroupStartCloseClick(Sender: TObject);
begin
  ButtonStart.Show;
  GroupBoxStart.hide;
end;

procedure TFormThermometer03Temperature.Renew(Sender: TObject);
begin
  //l
  ransuuHassei;
end;
procedure TFormThermometer03Temperature.LabelHyoudaiRenew(Sender: TObject);
begin
  LabelHyoudai1.Caption:= sRadioGroupBoardCharacter+
                          sRadioGroupLine+
                          sSpinEditMeterMax+
                          sSpinEditMeterMin+
                          sSpinEditThermoMax+
                          sSpinEditThermoMin+
                          sRadioGroupRandom+
                          sThermometerBarColor+
                          sThermometerTypeUnitKind;
end;

procedure TFormThermometer03Temperature.ButtonStartClick(Sender: TObject);
begin
  GroupBoxStart.show;
end;

procedure TFormThermometer03Temperature.RadioGroupBoardCharacterClick(Sender: TObject);
begin
  if RadioGroupBoardCharacter.ItemIndex=0 then
  begin
    Thermometer1.TypeCharacterDegree:=cd10;
    Thermometer2.TypeCharacterDegree:=cd10;
    Thermometer3.TypeCharacterDegree:=cd10;
    Thermometer4.TypeCharacterDegree:=cd10;
    Thermometer5.TypeCharacterDegree:=cd10;
    Thermometer6.TypeCharacterDegree:=cd10;
    sRadioGroupBoardCharacter:='ڐ̐:10x, ';
  end
  else
  begin
    Thermometer1.TypeCharacterDegree:=cd20;
    Thermometer2.TypeCharacterDegree:=cd20;
    Thermometer3.TypeCharacterDegree:=cd20;
    Thermometer4.TypeCharacterDegree:=cd20;
    Thermometer5.TypeCharacterDegree:=cd20;
    Thermometer6.TypeCharacterDegree:=cd20;
    sRadioGroupBoardCharacter:='ڐ̐:20x, ';
  end;
  LabelHyoudaiRenew(sender);
end;

procedure TFormThermometer03Temperature.RadioGroupLineClick(Sender: TObject);
begin
  case RadioGroupLine.ItemIndex of
    0:begin
        Thermometer1.TypeScaleInterval:=si01;
        Thermometer2.TypeScaleInterval:=si01;
        Thermometer3.TypeScaleInterval:=si01;
        Thermometer4.TypeScaleInterval:=si01;
        Thermometer5.TypeScaleInterval:=si01;
        Thermometer6.TypeScaleInterval:=si01;
        sRadioGroupLine:=':1x, ';
      end;
    1:begin
        Thermometer1.TypeScaleInterval:=si02;
        Thermometer2.TypeScaleInterval:=si02;
        Thermometer3.TypeScaleInterval:=si02;
        Thermometer4.TypeScaleInterval:=si02;
        Thermometer5.TypeScaleInterval:=si02;
        Thermometer6.TypeScaleInterval:=si02;
        sRadioGroupLine:=':2x, ';
      end;
    2:begin
        Thermometer1.TypeScaleInterval:=si05;
        Thermometer2.TypeScaleInterval:=si05;
        Thermometer3.TypeScaleInterval:=si05;
        Thermometer4.TypeScaleInterval:=si05;
        Thermometer5.TypeScaleInterval:=si05;
        Thermometer6.TypeScaleInterval:=si05;
        sRadioGroupLine:=':5x, ';
      end;
  end;
  LabelHyoudaiRenew(sender);
end;

procedure TFormThermometer03Temperature.RadioGroupUnitClick(Sender: TObject);
begin
  if RadioGroupUnit.ItemIndex=0 then
  begin
    Thermometer1.TypeUnitKind:=ukJapanese;
    Thermometer2.TypeUnitKind:=ukJapanese;
    Thermometer3.TypeUnitKind:=ukJapanese;
    Thermometer4.TypeUnitKind:=ukJapanese;
    Thermometer5.TypeUnitKind:=ukJapanese;
    Thermometer6.TypeUnitKind:=ukJapanese;
    LabelAnswer1.caption:='@@@@x';
    LabelAnswer2.caption:='@@@@x';
    LabelAnswer3.caption:='@@@@x';
    LabelAnswer4.caption:='@@@@x';
    LabelAnswer5.caption:='@@@@x';
    LabelAnswer6.caption:='@@@@x';
    sThermometerTypeUnitKind:='P:x';
    Label00.Caption:='xł傤B';
  end
  else
  begin
    Thermometer1.TypeUnitKind:=ukSign;
    Thermometer2.TypeUnitKind:=ukSign;
    Thermometer3.TypeUnitKind:=ukSign;
    Thermometer4.TypeUnitKind:=ukSign;
    Thermometer5.TypeUnitKind:=ukSign;
    Thermometer6.TypeUnitKind:=ukSign;
    LabelAnswer1.caption:='@@@@';
    LabelAnswer2.caption:='@@@@';
    LabelAnswer3.caption:='@@@@';
    LabelAnswer4.caption:='@@@@';
    LabelAnswer5.caption:='@@@@';
    LabelAnswer6.caption:='@@@@';
    sThermometerTypeUnitKind:='P:';
    Label00.Caption:='ł傤B';
  end;
  LabelHyoudaiRenew(sender);
end;

procedure TFormThermometer03Temperature.RadioGroupBarColorClick(Sender: TObject);
begin
  case RadioGroupBarColor.ItemIndex of
    0:begin
        Thermometer1.BarColor:= clRed;
        Thermometer2.BarColor:= clRed;
        Thermometer3.BarColor:= clRed;
        Thermometer4.BarColor:= clRed;
        Thermometer5.BarColor:= clRed;
        Thermometer6.BarColor:= clRed;
        sThermometerBarColor:='_̐F:, ';
      end;
    1:begin
        Thermometer1.BarColor:= clBlue;
        Thermometer2.BarColor:= clBlue;
        Thermometer3.BarColor:= clBlue;
        Thermometer4.BarColor:= clBlue;
        Thermometer5.BarColor:= clBlue;
        Thermometer6.BarColor:= clBlue;
        sThermometerBarColor:='_̐F:, ';
      end;
    2:begin
        Thermometer1.BarColor:= clSilver;
        Thermometer2.BarColor:= clSilver;
        Thermometer3.BarColor:= clSilver;
        Thermometer4.BarColor:= clSilver;
        Thermometer5.BarColor:= clSilver;
        Thermometer6.BarColor:= clSilver;
        sThermometerBarColor:='_̐F:, ';
      end;
    3:begin
        Thermometer1.BarColor:= clBlack;
        Thermometer2.BarColor:= clBlack;
        Thermometer3.BarColor:= clBlack;
        Thermometer4.BarColor:= clBlack;
        Thermometer5.BarColor:= clBlack;
        Thermometer6.BarColor:= clBlack;
        sThermometerBarColor:='_̐F:, ';
      end;
    4:begin
        Thermometer1.BarColor:= clGray;
        Thermometer2.BarColor:= clGray;
        Thermometer3.BarColor:= clGray;
        Thermometer4.BarColor:= clGray;
        Thermometer5.BarColor:= clGray;
        Thermometer6.BarColor:= clGray;
        sThermometerBarColor:='_̐F:D, ';
      end;
  end;
  LabelHyoudaiRenew(sender);
end;

procedure TFormThermometer03Temperature.SpinEditThermoMinChange(Sender: TObject);
begin
  if SpinEditThermoMin.Value> SpinEditThermoMin.MaxValue then SpinEditThermoMin.Value:=SpinEditThermoMin.MaxValue;
  if SpinEditThermoMin.Value< SpinEditMeterMin.Value then SpinEditThermoMin.Value:=SpinEditMeterMin.Value;
  if (SpinEditThermoMax.Value- SpinEditThermoMin.Value) /Division< 5 then
  begin
    SpinEditThermoMin.Value:= SpinEditThermoMin.Value-Division;
  end;
  sSpinEditThermoMin:='ŏl:'+inttostr(SpinEditThermoMin.value)+', ';
  LabelHyoudaiRenew(sender);
end;

procedure TFormThermometer03Temperature.SpinEditThermoMaxChange(Sender: TObject);
begin
  if SpinEditThermoMax.Value> SpinEditThermoMax.MaxValue then SpinEditThermoMax.Value:=SpinEditThermoMax.MaxValue;
  if SpinEditThermoMax.Value> SpinEditMeterMax.Value then SpinEditThermoMax.Value:=SpinEditMeterMax.Value;
  if ((SpinEditThermoMax.Value- SpinEditThermoMin.Value) /Division)< 5 then
  begin
    SpinEditThermoMax.Value:= SpinEditThermoMax.Value+Division;
  end;
  sSpinEditThermoMax:='x̍ől:'+inttostr(SpinEditThermoMax.value)+', ';
  LabelHyoudaiRenew(sender);
end;

procedure TFormThermometer03Temperature.SpinEditMeterMaxChange(Sender: TObject);
begin
  Thermometer1.ValueMax:=SpinEditMeterMax.Value;
  Thermometer2.ValueMax:=SpinEditMeterMax.Value;
  Thermometer3.ValueMax:=SpinEditMeterMax.Value;
  Thermometer4.ValueMax:=SpinEditMeterMax.Value;
  Thermometer5.ValueMax:=SpinEditMeterMax.Value;
  Thermometer6.ValueMax:=SpinEditMeterMax.Value;
  SpinEditMeterMax.Value:=SpinEditMeterMax.Value;
  sSpinEditMeterMax:='ڐ̍ől:'+inttostr(SpinEditMeterMax.value)+', ';
  LabelHyoudaiRenew(sender);
end;

procedure TFormThermometer03Temperature.SpinEditMeterMinChange(Sender: TObject);
begin
  Thermometer1.ValueMin:=SpinEditMeterMin.Value;
  Thermometer2.ValueMin:=SpinEditMeterMin.Value;
  Thermometer3.ValueMin:=SpinEditMeterMin.Value;
  Thermometer4.ValueMin:=SpinEditMeterMin.Value;
  Thermometer5.ValueMin:=SpinEditMeterMin.Value;
  Thermometer6.ValueMin:=SpinEditMeterMin.Value;
  SpinEditMeterMin.Value:=SpinEditMeterMin.Value;
  sSpinEditMeterMin:='ŏl:'+inttostr(SpinEditMeterMin.value)+', ';
  LabelHyoudaiRenew(sender);
end;

procedure TFormThermometer03Temperature.RadioGroupBackGroundColorClick(Sender: TObject);
begin
  if RadioGroupBackGroundColor.ItemIndex=0
  then
  begin
    Thermometer1.BoardColor:=clBtnFace;
    Thermometer2.BoardColor:=clBtnFace;
    Thermometer3.BoardColor:=clBtnFace;
    Thermometer4.BoardColor:=clBtnFace;
    Thermometer5.BoardColor:=clBtnFace;
    Thermometer6.BoardColor:=clBtnFace;
  end
  else
  begin
    Thermometer1.BoardColor:=clWhite;
    Thermometer2.BoardColor:=clWhite;
    Thermometer3.BoardColor:=clWhite;
    Thermometer4.BoardColor:=clWhite;
    Thermometer5.BoardColor:=clWhite;
    Thermometer6.BoardColor:=clWhite;
  end;
  LabelHyoudaiRenew(sender);
end;

end.
